# -*- ruby encoding: utf-8 -*-
#############################################################
# This file was automatically generated on 2016-09-08.      #
#                                                           #
# Ruby Bindings Version 2.1.10                              #
#                                                           #
# If you have a bugfix for this file and want to commit it, #
# please fix the bug in the generator. You can find a link  #
# to the generators git repository on tinkerforge.com       #
#############################################################

module Tinkerforge
  # Full fledged AHRS with 9 degrees of freedom
  class BrickIMUV2 < Device
    DEVICE_IDENTIFIER = 18 # :nodoc:
    DEVICE_DISPLAY_NAME = 'IMU Brick 2.0' # :nodoc:

    # This callback is triggered periodically with the period that is set by
    # BrickIMUV2#set_acceleration_period. The parameters are the acceleration
    # for the x, y and z axis.
    CALLBACK_ACCELERATION = 32

    # This callback is triggered periodically with the period that is set by
    # BrickIMUV2#set_magnetic_field_period. The parameters are the magnetic field
    # for the x, y and z axis.
    CALLBACK_MAGNETIC_FIELD = 33

    # This callback is triggered periodically with the period that is set by
    # BrickIMUV2#set_angular_velocity_period. The parameters are the angular velocity
    # for the x, y and z axis.
    CALLBACK_ANGULAR_VELOCITY = 34

    # This callback is triggered periodically with the period that is set by
    # BrickIMUV2#set_temperature_period. The parameter is the temperature.
    CALLBACK_TEMPERATURE = 35

    # This callback is triggered periodically with the period that is set by
    # BrickIMUV2#set_linear_acceleration_period. The parameters are the 
    # linear acceleration for the x, y and z axis.
    CALLBACK_LINEAR_ACCELERATION = 36

    # This callback is triggered periodically with the period that is set by
    # BrickIMUV2#set_gravity_vector_period. The parameters gravity vector
    # for the x, y and z axis.
    CALLBACK_GRAVITY_VECTOR = 37

    # This callback is triggered periodically with the period that is set by
    # BrickIMUV2#set_orientation_period. The parameters are the orientation
    # (heading (yaw), roll, pitch) of the IMU Brick in Euler angles. See
    # BrickIMUV2#get_orientation for details.
    CALLBACK_ORIENTATION = 38

    # This callback is triggered periodically with the period that is set by
    # BrickIMUV2#set_quaternion_period. The parameters are the orientation
    # (x, y, z, w) of the IMU Brick in quaternions. See BrickIMUV2#get_quaternion
    # for details.
    CALLBACK_QUATERNION = 39

    # This callback is triggered periodically with the period that is set by
    # BrickIMUV2#set_all_data_period. The parameters are as for BrickIMUV2#get_all_data.
    CALLBACK_ALL_DATA = 40

    FUNCTION_GET_ACCELERATION = 1 # :nodoc:
    FUNCTION_GET_MAGNETIC_FIELD = 2 # :nodoc:
    FUNCTION_GET_ANGULAR_VELOCITY = 3 # :nodoc:
    FUNCTION_GET_TEMPERATURE = 4 # :nodoc:
    FUNCTION_GET_ORIENTATION = 5 # :nodoc:
    FUNCTION_GET_LINEAR_ACCELERATION = 6 # :nodoc:
    FUNCTION_GET_GRAVITY_VECTOR = 7 # :nodoc:
    FUNCTION_GET_QUATERNION = 8 # :nodoc:
    FUNCTION_GET_ALL_DATA = 9 # :nodoc:
    FUNCTION_LEDS_ON = 10 # :nodoc:
    FUNCTION_LEDS_OFF = 11 # :nodoc:
    FUNCTION_ARE_LEDS_ON = 12 # :nodoc:
    FUNCTION_SAVE_CALIBRATION = 13 # :nodoc:
    FUNCTION_SET_ACCELERATION_PERIOD = 14 # :nodoc:
    FUNCTION_GET_ACCELERATION_PERIOD = 15 # :nodoc:
    FUNCTION_SET_MAGNETIC_FIELD_PERIOD = 16 # :nodoc:
    FUNCTION_GET_MAGNETIC_FIELD_PERIOD = 17 # :nodoc:
    FUNCTION_SET_ANGULAR_VELOCITY_PERIOD = 18 # :nodoc:
    FUNCTION_GET_ANGULAR_VELOCITY_PERIOD = 19 # :nodoc:
    FUNCTION_SET_TEMPERATURE_PERIOD = 20 # :nodoc:
    FUNCTION_GET_TEMPERATURE_PERIOD = 21 # :nodoc:
    FUNCTION_SET_ORIENTATION_PERIOD = 22 # :nodoc:
    FUNCTION_GET_ORIENTATION_PERIOD = 23 # :nodoc:
    FUNCTION_SET_LINEAR_ACCELERATION_PERIOD = 24 # :nodoc:
    FUNCTION_GET_LINEAR_ACCELERATION_PERIOD = 25 # :nodoc:
    FUNCTION_SET_GRAVITY_VECTOR_PERIOD = 26 # :nodoc:
    FUNCTION_GET_GRAVITY_VECTOR_PERIOD = 27 # :nodoc:
    FUNCTION_SET_QUATERNION_PERIOD = 28 # :nodoc:
    FUNCTION_GET_QUATERNION_PERIOD = 29 # :nodoc:
    FUNCTION_SET_ALL_DATA_PERIOD = 30 # :nodoc:
    FUNCTION_GET_ALL_DATA_PERIOD = 31 # :nodoc:
    FUNCTION_ENABLE_STATUS_LED = 238 # :nodoc:
    FUNCTION_DISABLE_STATUS_LED = 239 # :nodoc:
    FUNCTION_IS_STATUS_LED_ENABLED = 240 # :nodoc:
    FUNCTION_GET_PROTOCOL1_BRICKLET_NAME = 241 # :nodoc:
    FUNCTION_GET_CHIP_TEMPERATURE = 242 # :nodoc:
    FUNCTION_RESET = 243 # :nodoc:
    FUNCTION_GET_IDENTITY = 255 # :nodoc:


    # Creates an object with the unique device ID <tt>uid</tt> and adds it to
    # the IP Connection <tt>ipcon</tt>.
    def initialize(uid, ipcon)
      super uid, ipcon

      @api_version = [2, 0, 0]

      @response_expected[FUNCTION_GET_ACCELERATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_MAGNETIC_FIELD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_ANGULAR_VELOCITY] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_TEMPERATURE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_ORIENTATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_LINEAR_ACCELERATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_GRAVITY_VECTOR] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_QUATERNION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_ALL_DATA] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_LEDS_ON] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_LEDS_OFF] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_ARE_LEDS_ON] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SAVE_CALIBRATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_ACCELERATION_PERIOD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_ACCELERATION_PERIOD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_MAGNETIC_FIELD_PERIOD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_MAGNETIC_FIELD_PERIOD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_ANGULAR_VELOCITY_PERIOD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_ANGULAR_VELOCITY_PERIOD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_TEMPERATURE_PERIOD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_TEMPERATURE_PERIOD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_ORIENTATION_PERIOD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_ORIENTATION_PERIOD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_LINEAR_ACCELERATION_PERIOD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_LINEAR_ACCELERATION_PERIOD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_GRAVITY_VECTOR_PERIOD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_GRAVITY_VECTOR_PERIOD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_QUATERNION_PERIOD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_QUATERNION_PERIOD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_ALL_DATA_PERIOD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_ALL_DATA_PERIOD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[CALLBACK_ACCELERATION] = RESPONSE_EXPECTED_ALWAYS_FALSE
      @response_expected[CALLBACK_MAGNETIC_FIELD] = RESPONSE_EXPECTED_ALWAYS_FALSE
      @response_expected[CALLBACK_ANGULAR_VELOCITY] = RESPONSE_EXPECTED_ALWAYS_FALSE
      @response_expected[CALLBACK_TEMPERATURE] = RESPONSE_EXPECTED_ALWAYS_FALSE
      @response_expected[CALLBACK_LINEAR_ACCELERATION] = RESPONSE_EXPECTED_ALWAYS_FALSE
      @response_expected[CALLBACK_GRAVITY_VECTOR] = RESPONSE_EXPECTED_ALWAYS_FALSE
      @response_expected[CALLBACK_ORIENTATION] = RESPONSE_EXPECTED_ALWAYS_FALSE
      @response_expected[CALLBACK_QUATERNION] = RESPONSE_EXPECTED_ALWAYS_FALSE
      @response_expected[CALLBACK_ALL_DATA] = RESPONSE_EXPECTED_ALWAYS_FALSE
      @response_expected[FUNCTION_ENABLE_STATUS_LED] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_DISABLE_STATUS_LED] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_IS_STATUS_LED_ENABLED] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_PROTOCOL1_BRICKLET_NAME] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_CHIP_TEMPERATURE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_RESET] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_IDENTITY] = RESPONSE_EXPECTED_ALWAYS_TRUE

      @callback_formats[CALLBACK_ACCELERATION] = 's s s'
      @callback_formats[CALLBACK_MAGNETIC_FIELD] = 's s s'
      @callback_formats[CALLBACK_ANGULAR_VELOCITY] = 's s s'
      @callback_formats[CALLBACK_TEMPERATURE] = 'c'
      @callback_formats[CALLBACK_LINEAR_ACCELERATION] = 's s s'
      @callback_formats[CALLBACK_GRAVITY_VECTOR] = 's s s'
      @callback_formats[CALLBACK_ORIENTATION] = 's s s'
      @callback_formats[CALLBACK_QUATERNION] = 's s s s'
      @callback_formats[CALLBACK_ALL_DATA] = 's3 s3 s3 s3 s4 s3 s3 c C'
    end

    # Returns the calibrated acceleration from the accelerometer for the 
    # x, y and z axis in 1/100 m/s².
    # 
    # If you want to get the acceleration periodically, it is recommended 
    # to use the callback CALLBACK_ACCELERATION and set the period with 
    # BrickIMUV2#set_acceleration_period.
    def get_acceleration
      send_request(FUNCTION_GET_ACCELERATION, [], '', 6, 's s s')
    end

    # Returns the calibrated magnetic field from the magnetometer for the 
    # x, y and z axis in 1/16 µT (Microtesla).
    # 
    # If you want to get the magnetic field periodically, it is recommended 
    # to use the callback CALLBACK_MAGNETIC_FIELD and set the period with 
    # BrickIMUV2#set_magnetic_field_period.
    def get_magnetic_field
      send_request(FUNCTION_GET_MAGNETIC_FIELD, [], '', 6, 's s s')
    end

    # Returns the calibrated angular velocity from the gyroscope for the 
    # x, y and z axis in 1/16 °/s.
    # 
    # If you want to get the angular velocity periodically, it is recommended 
    # to use the callback CALLBACK_ANGULAR_VELOCITY and set the period with 
    # BrickIMUV2#set_angular_velocity_period.
    def get_angular_velocity
      send_request(FUNCTION_GET_ANGULAR_VELOCITY, [], '', 6, 's s s')
    end

    # Returns the temperature of the IMU Brick. The temperature is given in 
    # °C. The temperature is measured in the core of the BNO055 IC, it is not the
    # ambient temperature
    def get_temperature
      send_request(FUNCTION_GET_TEMPERATURE, [], '', 1, 'c')
    end

    # Returns the current orientation (heading, roll, pitch) of the IMU Brick as
    # independent Euler angles in 1/16 degree. Note that Euler angles always
    # experience a `gimbal lock <https://en.wikipedia.org/wiki/Gimbal_lock>`__. We
    # recommend that you use quaternions instead, if you need the absolute orientation.
    # 
    # The rotation angle has the following ranges:
    # 
    # * heading: 0° to 360°
    # * roll: -90° to +90°
    # * pitch: -180° to +180°
    # 
    # If you want to get the orientation periodically, it is recommended 
    # to use the callback CALLBACK_ORIENTATION and set the period with 
    # BrickIMUV2#set_orientation_period.
    def get_orientation
      send_request(FUNCTION_GET_ORIENTATION, [], '', 6, 's s s')
    end

    # Returns the linear acceleration of the IMU Brick for the
    # x, y and z axis in 1/100 m/s².
    # 
    # The linear acceleration is the acceleration in each of the three
    # axis of the IMU Brick with the influences of gravity removed.
    # 
    # It is also possible to get the gravity vector with the influence of linear
    # acceleration removed, see BrickIMUV2#get_gravity_vector.
    # 
    # If you want to get the linear acceleration periodically, it is recommended 
    # to use the callback CALLBACK_LINEAR_ACCELERATION and set the period with 
    # BrickIMUV2#set_linear_acceleration_period.
    def get_linear_acceleration
      send_request(FUNCTION_GET_LINEAR_ACCELERATION, [], '', 6, 's s s')
    end

    # Returns the current gravity vector of the IMU Brick for the
    # x, y and z axis in 1/100 m/s².
    # 
    # The gravity vector is the acceleration that occurs due to gravity.
    # Influences of additional linear acceleration are removed.
    # 
    # It is also possible to get the linear acceleration with the influence 
    # of gravity removed, see BrickIMUV2#get_linear_acceleration.
    # 
    # If you want to get the gravity vector periodically, it is recommended 
    # to use the callback CALLBACK_GRAVITY_VECTOR and set the period with 
    # BrickIMUV2#set_gravity_vector_period.
    def get_gravity_vector
      send_request(FUNCTION_GET_GRAVITY_VECTOR, [], '', 6, 's s s')
    end

    # Returns the current orientation (w, x, y, z) of the IMU Brick as
    # `quaternions <https://en.wikipedia.org/wiki/Quaternions_and_spatial_rotation>`__.
    # 
    # You have to divide the returns values by 16383 (14 bit) to get
    # the usual range of -1.0 to +1.0 for quaternions.
    # 
    # If you want to get the quaternions periodically, it is recommended 
    # to use the callback CALLBACK_QUATERNION and set the period with 
    # BrickIMUV2#set_quaternion_period.
    def get_quaternion
      send_request(FUNCTION_GET_QUATERNION, [], '', 8, 's s s s')
    end

    # Return all of the available data of the IMU Brick.
    # 
    # * acceleration in 1/100 m/s² (see BrickIMUV2#get_acceleration)
    # * magnetic field in 1/16 µT (see BrickIMUV2#get_magnetic_field)
    # * angular velocity in 1/16 °/s (see BrickIMUV2#get_angular_velocity)
    # * Euler angles in 1/16 ° (see BrickIMUV2#get_orientation)
    # * quaternion 1/16383 (see BrickIMUV2#get_quaternion)
    # * linear acceleration 1/100 m/s² (see BrickIMUV2#get_linear_acceleration)
    # * gravity vector 1/100 m/s² (see BrickIMUV2#get_gravity_vector)
    # * temperature in 1 °C (see BrickIMUV2#get_temperature)
    # * calibration status (see below)
    # 
    # The calibration status consists of four pairs of two bits. Each pair
    # of bits represents the status of the current calibration.
    # 
    # * bit 0-1: Magnetometer
    # * bit 2-3: Accelerometer
    # * bit 4-5: Gyroscope
    # * bit 6-7: System
    # 
    # A value of 0 means for "not calibrated" and a value of 3 means
    # "fully calibrated". In your program you should always be able to
    # ignore the calibration status, it is used by the calibration
    # window of the Brick Viewer and it can be ignored after the first
    # calibration. See the documentation in the calibration window for
    # more information regarding the calibration of the IMU Brick.
    # 
    # If you want to get the data periodically, it is recommended 
    # to use the callback CALLBACK_ALL_DATA and set the period with 
    # BrickIMUV2#set_all_data_period.
    def get_all_data
      send_request(FUNCTION_GET_ALL_DATA, [], '', 46, 's3 s3 s3 s3 s4 s3 s3 c C')
    end

    # Turns the orientation and direction LEDs of the IMU Brick on.
    def leds_on
      send_request(FUNCTION_LEDS_ON, [], '', 0, '')
    end

    # Turns the orientation and direction LEDs of the IMU Brick off.
    def leds_off
      send_request(FUNCTION_LEDS_OFF, [], '', 0, '')
    end

    # Returns *true* if the orientation and direction LEDs of the IMU Brick
    # are on, *false* otherwise.
    def are_leds_on
      send_request(FUNCTION_ARE_LEDS_ON, [], '', 1, '?')
    end

    # A call of this function saves the current calibration to be used
    # as a starting point for the next restart of continuous calibration
    # of the IMU Brick.
    # 
    # A return value of *true* means that the calibration could be used and
    # *false* means that it could not be used (this happens if the calibration 
    # status is not "fully calibrated").
    # 
    # This function is used by the calibration window of the Brick Viewer, you
    # should not need to call it in your program.
    def save_calibration
      send_request(FUNCTION_SAVE_CALIBRATION, [], '', 1, '?')
    end

    # Sets the period in ms with which the CALLBACK_ACCELERATION callback is triggered
    # periodically. A value of 0 turns the callback off.
    # 
    # The default value is 0.
    def set_acceleration_period(period)
      send_request(FUNCTION_SET_ACCELERATION_PERIOD, [period], 'L', 0, '')
    end

    # Returns the period as set by BrickIMUV2#set_acceleration_period.
    def get_acceleration_period
      send_request(FUNCTION_GET_ACCELERATION_PERIOD, [], '', 4, 'L')
    end

    # Sets the period in ms with which the CALLBACK_MAGNETIC_FIELD callback is triggered
    # periodically. A value of 0 turns the callback off.
    def set_magnetic_field_period(period)
      send_request(FUNCTION_SET_MAGNETIC_FIELD_PERIOD, [period], 'L', 0, '')
    end

    # Returns the period as set by BrickIMUV2#set_magnetic_field_period.
    def get_magnetic_field_period
      send_request(FUNCTION_GET_MAGNETIC_FIELD_PERIOD, [], '', 4, 'L')
    end

    # Sets the period in ms with which the CALLBACK_ANGULAR_VELOCITY callback is triggered
    # periodically. A value of 0 turns the callback off.
    def set_angular_velocity_period(period)
      send_request(FUNCTION_SET_ANGULAR_VELOCITY_PERIOD, [period], 'L', 0, '')
    end

    # Returns the period as set by BrickIMUV2#set_angular_velocity_period.
    def get_angular_velocity_period
      send_request(FUNCTION_GET_ANGULAR_VELOCITY_PERIOD, [], '', 4, 'L')
    end

    # Sets the period in ms with which the CALLBACK_TEMPERATURE callback is triggered
    # periodically. A value of 0 turns the callback off.
    def set_temperature_period(period)
      send_request(FUNCTION_SET_TEMPERATURE_PERIOD, [period], 'L', 0, '')
    end

    # Returns the period as set by BrickIMUV2#set_temperature_period.
    def get_temperature_period
      send_request(FUNCTION_GET_TEMPERATURE_PERIOD, [], '', 4, 'L')
    end

    # Sets the period in ms with which the CALLBACK_ORIENTATION callback is triggered
    # periodically. A value of 0 turns the callback off.
    def set_orientation_period(period)
      send_request(FUNCTION_SET_ORIENTATION_PERIOD, [period], 'L', 0, '')
    end

    # Returns the period as set by BrickIMUV2#set_orientation_period.
    def get_orientation_period
      send_request(FUNCTION_GET_ORIENTATION_PERIOD, [], '', 4, 'L')
    end

    # Sets the period in ms with which the CALLBACK_LINEAR_ACCELERATION callback is triggered
    # periodically. A value of 0 turns the callback off.
    def set_linear_acceleration_period(period)
      send_request(FUNCTION_SET_LINEAR_ACCELERATION_PERIOD, [period], 'L', 0, '')
    end

    # Returns the period as set by BrickIMUV2#set_linear_acceleration_period.
    def get_linear_acceleration_period
      send_request(FUNCTION_GET_LINEAR_ACCELERATION_PERIOD, [], '', 4, 'L')
    end

    # Sets the period in ms with which the CALLBACK_GRAVITY_VECTOR callback is triggered
    # periodically. A value of 0 turns the callback off.
    def set_gravity_vector_period(period)
      send_request(FUNCTION_SET_GRAVITY_VECTOR_PERIOD, [period], 'L', 0, '')
    end

    # Returns the period as set by BrickIMUV2#set_gravity_vector_period.
    def get_gravity_vector_period
      send_request(FUNCTION_GET_GRAVITY_VECTOR_PERIOD, [], '', 4, 'L')
    end

    # Sets the period in ms with which the CALLBACK_QUATERNION callback is triggered
    # periodically. A value of 0 turns the callback off.
    def set_quaternion_period(period)
      send_request(FUNCTION_SET_QUATERNION_PERIOD, [period], 'L', 0, '')
    end

    # Returns the period as set by BrickIMUV2#set_quaternion_period.
    def get_quaternion_period
      send_request(FUNCTION_GET_QUATERNION_PERIOD, [], '', 4, 'L')
    end

    # Sets the period in ms with which the CALLBACK_ALL_DATA callback is triggered
    # periodically. A value of 0 turns the callback off.
    def set_all_data_period(period)
      send_request(FUNCTION_SET_ALL_DATA_PERIOD, [period], 'L', 0, '')
    end

    # Returns the period as set by BrickIMUV2#set_all_data_period.
    def get_all_data_period
      send_request(FUNCTION_GET_ALL_DATA_PERIOD, [], '', 4, 'L')
    end

    # Enables the status LED.
    # 
    # The status LED is the blue LED next to the USB connector. If enabled is is
    # on and it flickers if data is transfered. If disabled it is always off.
    # 
    # The default state is enabled.
    def enable_status_led
      send_request(FUNCTION_ENABLE_STATUS_LED, [], '', 0, '')
    end

    # Disables the status LED.
    # 
    # The status LED is the blue LED next to the USB connector. If enabled is is
    # on and it flickers if data is transfered. If disabled it is always off.
    # 
    # The default state is enabled.
    def disable_status_led
      send_request(FUNCTION_DISABLE_STATUS_LED, [], '', 0, '')
    end

    # Returns *true* if the status LED is enabled, *false* otherwise.
    def is_status_led_enabled
      send_request(FUNCTION_IS_STATUS_LED_ENABLED, [], '', 1, '?')
    end

    # Returns the firmware and protocol version and the name of the Bricklet for a
    # given port.
    # 
    # This functions sole purpose is to allow automatic flashing of v1.x.y Bricklet
    # plugins.
    def get_protocol1_bricklet_name(port)
      send_request(FUNCTION_GET_PROTOCOL1_BRICKLET_NAME, [port], 'k', 44, 'C C3 Z40')
    end

    # Returns the temperature in °C/10 as measured inside the microcontroller. The
    # value returned is not the ambient temperature!
    # 
    # The temperature is only proportional to the real temperature and it has an
    # accuracy of +-15%. Practically it is only useful as an indicator for
    # temperature changes.
    def get_chip_temperature
      send_request(FUNCTION_GET_CHIP_TEMPERATURE, [], '', 2, 's')
    end

    # Calling this function will reset the Brick. Calling this function
    # on a Brick inside of a stack will reset the whole stack.
    # 
    # After a reset you have to create new device objects,
    # calling functions on the existing ones will result in
    # undefined behavior!
    def reset
      send_request(FUNCTION_RESET, [], '', 0, '')
    end

    # Returns the UID, the UID where the Brick is connected to, 
    # the position, the hardware and firmware version as well as the
    # device identifier.
    # 
    # The position can be '0'-'8' (stack position).
    # 
    # The device identifier numbers can be found :ref:`here <device_identifier>`.
    # |device_identifier_constant|
    def get_identity
      send_request(FUNCTION_GET_IDENTITY, [], '', 25, 'Z8 Z8 k C3 C3 S')
    end

    # Registers a callback with ID <tt>id</tt> to the block <tt>block</tt>.
    def register_callback(id, &block)
      callback = block
      @registered_callbacks[id] = callback
    end
  end
end
