# -*- ruby encoding: utf-8 -*-
#############################################################
# This file was automatically generated on 2016-09-08.      #
#                                                           #
# Ruby Bindings Version 2.1.10                              #
#                                                           #
# If you have a bugfix for this file and want to commit it, #
# please fix the bug in the generator. You can find a link  #
# to the generators git repository on tinkerforge.com       #
#############################################################

module Tinkerforge
  # Passive infrared (PIR) motion sensor, 7m range
  class BrickletMotionDetector < Device
    DEVICE_IDENTIFIER = 233 # :nodoc:
    DEVICE_DISPLAY_NAME = 'Motion Detector Bricklet' # :nodoc:

    # This callback is called after a motion was detected.
    CALLBACK_MOTION_DETECTED = 2

    # This callback is called when the detection cycle ended. When this
    # callback is called, a new motion can be detected again after approximately 2
    # seconds.
    CALLBACK_DETECTION_CYCLE_ENDED = 3

    FUNCTION_GET_MOTION_DETECTED = 1 # :nodoc:
    FUNCTION_GET_IDENTITY = 255 # :nodoc:

    MOTION_NOT_DETECTED = 0 # :nodoc:
    MOTION_DETECTED = 1 # :nodoc:

    # Creates an object with the unique device ID <tt>uid</tt> and adds it to
    # the IP Connection <tt>ipcon</tt>.
    def initialize(uid, ipcon)
      super uid, ipcon

      @api_version = [2, 0, 0]

      @response_expected[FUNCTION_GET_MOTION_DETECTED] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[CALLBACK_MOTION_DETECTED] = RESPONSE_EXPECTED_ALWAYS_FALSE
      @response_expected[CALLBACK_DETECTION_CYCLE_ENDED] = RESPONSE_EXPECTED_ALWAYS_FALSE
      @response_expected[FUNCTION_GET_IDENTITY] = RESPONSE_EXPECTED_ALWAYS_TRUE

      @callback_formats[CALLBACK_MOTION_DETECTED] = ''
      @callback_formats[CALLBACK_DETECTION_CYCLE_ENDED] = ''
    end

    # Returns 1 if a motion was detected. How long this returns 1 after a motion
    # was detected can be adjusted with one of the small potentiometers on the
    # Motion Detector Bricklet, see :ref:`here
    # <motion_detector_bricklet_sensitivity_delay_block_time>`.
    # 
    # There is also a blue LED on the Bricklet that is on as long as the Bricklet is
    # in the "motion detected" state.
    def get_motion_detected
      send_request(FUNCTION_GET_MOTION_DETECTED, [], '', 1, 'C')
    end

    # Returns the UID, the UID where the Bricklet is connected to, 
    # the position, the hardware and firmware version as well as the
    # device identifier.
    # 
    # The position can be 'a', 'b', 'c' or 'd'.
    # 
    # The device identifier numbers can be found :ref:`here <device_identifier>`.
    # |device_identifier_constant|
    def get_identity
      send_request(FUNCTION_GET_IDENTITY, [], '', 25, 'Z8 Z8 k C3 C3 S')
    end

    # Registers a callback with ID <tt>id</tt> to the block <tt>block</tt>.
    def register_callback(id, &block)
      callback = block
      @registered_callbacks[id] = callback
    end
  end
end
